' --- ExpressenTicker.vbs --
' This script retrieves the latest news shown on Expressen News-Ticker
' articleCount specifies how many articles to retrieve
'
' Version 0.2
' Author: Anders Orsedal <orsedal@hotmail.com>
'
' --- ExpressenTicker.vbs --

' You may have to change this url:
const TICKER_URL = "http://www.expressen.se/expressen/jsp/ticker/"

Function getNews(articleCount)
	Dim html
	Redim strDate(articleCount), strNewsText(articleCount)
	html = ReturnHTML(TICKER_URL)
	Set RE = New RegExp
    RE.Global = True
    
    'Hmta tiden
    RE.Pattern = "[0-9]{2}[:][0-9]{2}"
    Set datetemp = RE.Execute(html)
    For i = 0 To articleCount -1
		strDate(i) = datetemp(i)
    Next
    
    'Hmta nyhetstexten
    RE.Pattern = "<span class=""whitePlain"">(.*?)</span></a>"
	Set titletemp = RE.Execute(html)

    For i = 0 To articleCount - 1
    	Set oMatch = titletemp(i)
      	strNewsText(i) = oMatch.SubMatches(0)
    Next
    
	For i = 0 To articleCount - 1
    	getNews = getNews & strDate(i) & " " & RemoveHTML(strNewsText(i)) & "%b"
   	Next


End Function

Function RemoveHTML(strHTML)
	Set RE = New RegExp
	RE.Global = true
	html = strHTML

	html = replace(html, "<BR>", " ")
	html = replace(html, Chr(10), " ")
	html = replace(html, "&Aring;", "")
	html = replace(html, "&Auml;", "")
	html = replace(html, "&Ouml;", "")
	html = replace(html, "&aring;", "")
	html = replace(html, "&#8221", """")
	html = replace(html, "&#148;", """")
	html = replace(html, "&quot;", """")
	html = replace(html, "&rdquo;", """")
	html = replace(html, "&eacute;", "")
	html = replace(html, "&auml;", "")
	html = replace(html, "&ouml;", "")
	html = replace(html, "&nbsp;", " ")
	html = replace(html, "&raquo;", "%b")
	html = replace(html, "&eacute;", "")
	html = replace(html, "&ndash;", "-")
	html = replace(html, "  ", " ")
	
	'Remove html tags
    RE.Pattern = "<(.*?)>"
    html = RE.Replace(html, "")
    RE.Pattern = "</(.*?)>"
    html = RE.Replace(html, "")
	
	
	RemoveHTML = html
	
End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
	On Error Resume Next
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	if err = 0 then
		HTML = objXMLHTTP.responseBody
		Set objRS = CreateObject("ADODB.Recordset")
		objRS.Fields.Append "txt", 200, 35000, &H00000080
		objRS.Open
		objRS.AddNew
		objRS.Fields("txt").AppendChunk HTML
		ReturnHTML = objRS("txt").Value
		objRS.Close
		Set objRS = Nothing
	else
		ReturnHTML = ERROR_MSG
	end if
	On Error GoTo 0
	Set objXMLHTTP = Nothing
End Function
